// Definizione e testing di una funzione che calcola il massimo tra 2
// valori interi e lo memorizza in una variabile

// inclusione dell'header file della libreria standard di
// definizioni di macro, costanti e dichiarazioni di funzioni e tipi
// per le varie operazioni di input/output

#include <stdio.h>

// Definizione della funzione

void massimoTraDue (int x, int y, int * target)
   // Parametri formali
   //    x:      primo valore
   //    y:      secondo valore
   //    target: indirizzo della variabile che memorizzera' il massimo 
   {
   // determino il massimo tra i due valori
   if (x>y)
     // aggiorno la variabile di indirizzo target con il valore di x
     *target = x;
   else
     // saggiorno la variabile di indirizzo target con il valore di y
     *target = y;
   }

// Testing della funzione

int main()
   {
   // definizione delle variabili per l'input
   int a, b;

   // definizione della variabile per il massimo
   int destinazione;

   // acquisisco il primo valore
   printf("\nDammi il primo valore: ");
   scanf("%d", &a);
   
   // acquisisco il secondo valore
   printf("\nDammi il secondo valore: ");
   scanf("%d", &b);

   // calcolo il massimo e lo memorizzo nella variabile destinazione
   massimoTraDue(a, b, &destinazione);

   // visualizzo il contenuto della variabile destinazione
   printf("\nIl massimo tra %d e %d e' %d", a, b, destinazione);

   return(1);
   }
 